% this function computes and prints simple and hamming distances
% between 2 strings input by user

function manualmethod()

% user inputs strings
% need to test lots of things
% - upper or lower? convert to lower
% - illegal chars? reject string? 
% - mismatched length?

string1 = '0';
string2 = string1;
while(string1=='0' | string2=='0')
    [string1 string2] = getstrings;
end

fprintf( 'The hamming distance is %d.\n', ...
             hammingdistance(string1,string2));
fprintf( 'The weighted distance is %d.\n\n', ...          
          weighteddistance(string1,string2));

function [string1, string2] =  getstrings()
  
   string1 = upper(input('Enter first string: ','s'));
   while teststring(string1)~=1
      string1 = upper(input('Enter first string: ','s'));
   end

   string2 = upper(input('Enter second string: ','s'));
   while teststring(string2)~=1
      string2 = upper(input('Enter second string: ','s'));
   end

   if length(string1) ~= length(string2)
      disp('Holy crap! String lengths are different!');
      string1 = '0';
      string2 = string1;
   end
   
   % input  : string
   % output : if string contains valid characters returns true
   %          otherwise returns false
   % Also indicates which characters of string are invalid
function test = teststring(string)

   bad = string ~='A' &  string ~='C' & string ~='G' & string ~= 'T';

   if sum(bad) ~= 0
      disp('This string is bad! Here is why:');
      indicators=char(zeros(1,length(string))+' ');
      indicators(bad)='^'; 
      disp(string);
      disp(indicators);
      test = 0; % return false
   else
      test = 1; % return true
   end
