function choice = getinput()

% getinput
%
% user chooses input method:
% 1) program generates 2 randomly
%    - only acceptable chars
%    - must be same length
% 2) manual (enter 2 strings)
%    - only acceptable chars
%    - must be same length
% 3) read n strings from file
%    - compare each with eachother
%    - not assume each is the same length
%    - only compare lengths with same-lengths 
%    - test with file containing 0-n strings

  c1=1;c2=2;c3=3;c4=4;
  disp('Enter choice of input:');
  disp('(r) Program generates 2 random strings');
  disp('(u) User enters 2 strings');
  disp('(f) Read strings from a file');
  choice = input('[r,u,f]: ','s');
  while(length(choice)~=1 | ~(choice=='r' | choice=='u' | choice=='f'))
     choice = input('No! You must choose either r, u, or f: ','s');
  end

