% hammingdistance.m

% inputs: s1 and s2 (strings to test)
% ouput:  hammingd  (hamming distance) 
             
function hammingd = hammingdistance(s1,s2)

% should put error check for s1 and s2

   if checkchars(s1) & checkchars(s2) & length(s1)==length(s2)
      % s1~=s2 generates a logical array of differences
      % 'sum' adds up all elements of this
      % logical array giving the simple dist  
      hammingd = sum(s1~=s2);
   else
     error('Strings contain incorrect characters or have different lengths!');
   end
   
